var express = require('express');
var async = require('async');
var cmb = require('./cmb-bank.js');

var app = express();

app.get('/:id/:pwd/', function (request, response) {
    console.log('Go !');

    var result = {};
    result.compte = [];
    result.livret = [];

    async.waterfall([
        function(cb){
            cmb.login(request.params.id, request.params.pwd).then(function (token) {
                cb(null);
            });            
        },
        function (cb) {
            console.log('start infosPerson');
            cmb.infosPerson().then(function (user) {
                result.user = user;
                console.log('end infosPerson');
                cb(null);
            });
        },
        function (cb) {
            console.log('start synthesecomptes');
            cmb.synthesecomptes().then(function (accounts) {
                for (account of accounts.listCompteTitulaireCotitulaire) {
                    switch (account.accountType) {
                        case 'LIVRET':
                            result.livret.push(account);
                            break;
                        case 'COURANT':
                            result.compte.push(account);
                            break;
                    }
                }
                Object.keys(accounts.listCompteMandataire).forEach(function (k) {
                    for (account of accounts.listCompteMandataire[k]) {
                        switch (account.accountType) {
                            case 'LIVRET':
                                result.livret.push(account);
                                break;
                            case 'COURANT':
                                result.compte.push(account);
                                break;
                        }
                    }
                });
                console.log('end synthesecomptes');
                cb(null);
            });
        }
        ,
        function (cb) {
            var comptes = [];
            console.log('start pending');
            async.map(result.compte, function(compte, callback) {
                cmb.pendingListOperations(compte.index).then(function (res) {
                    compte.attente = res;
                    comptes.push(compte);
                    callback(null);
                });
            }, function(err, res){
                console.log('stop pending');
                result.compte = comptes;
                cb(null);
            });
        }
    ], function (err, res) {
        console.log(result);
        response.setHeader("Access-Control-Allow-Origin", "*");
        response.send(JSON.stringify(result));
    });
    
})



var server = app.listen(8081, function () {
    var host = server.address().address
    var port = server.address().port
    console.log("Example app listening at http://%s:%s", host, port)

})